; +
;
MmCrc proc uses esi edi P:PVOID
Local Image[MAX_PATH*2]:CHAR
Local Nam3[MAX_PATH]:CHAR
	lea  eax, Image
	push 0
	push MAX_PATH*2
	push eax
	push MemoryMappedFilenameInformation
	push P
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
	.if  !Eax
		mov   edi, UNICODE_STRING.Buffer[Image]
		movzx ecx, UNICODE_STRING._Length[Image]
		add   edi, ecx
		std
		shr   ecx, 1
		mov   ax,  "\"
		mov   edx, ecx
		repne scasw
		cld
		add   edi, 4
		not   ecx
		add   ecx, edx
		lea   esi, Nam3
		lea   edx, [ecx][-1]
		xchg  esi, edi
		.repeat
			lodsw
			or  al, 32
			stosb
			dec ecx
		.until Zero?
		invoke Crc32, CRC32_BASE, addr Nam3, Edx
	.else
		xor eax, eax
	.endif
	ret
MmCrc           endp


; +
;
; +
;
MmQueryViewSize proc uses esi ebx Base:PVOID, Range:PRANGE
Local           Mem:MEMORY_BASIC_INFORMATION
    mov  eax,             Base
    xor  esi,             esi
    lea  ecx,             Mem
    mov  Mem.BaseAddress, eax
    push 0
    push sizeof(MEMORY_BASIC_INFORMATION)
    push ecx
    push MemoryBasicInformation
    push Mem.BaseAddress
    push NtCurrentProcess
    %PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
    .if  !Eax
        mov esi, Mem.AllocationBase
        .repeat
            mov  eax,             Mem.RegionSize
            lea  ecx,             Mem
            add  Mem.BaseAddress, eax
            push 0
            push sizeof(MEMORY_BASIC_INFORMATION)
            push ecx
            push MemoryBasicInformation
            push Mem.BaseAddress
            push NtCurrentProcess
            %PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
            test eax,             eax
            jnz  Exit
        .until Mem.AllocationBase != Esi
        mov    ecx,              Range
        mov    edx,              Mem.BaseAddress
        xor    eax,              eax
        mov    RANGE.Base[ecx],  esi
        mov    RANGE.Limit[ecx], edx
    .endif
Exit:
    ret
MmQueryViewSize endp

%CHKSTK macro N
	mov eax, esp
	mov ecx, N
	.repeat
		sub eax,            PAGE_SIZE
		cmp DWORD PTR[eax], eax
	.untilcxz
endm

; +
;
WsEmpty proc
Local   Ps:QUOTA_LIMITS
	lea  eax, Ps
	push NULL
	push sizeof(QUOTA_LIMITS)
	push eax
	push ProcessQuotaLimits
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_INFORMATION_PROCESS, 5
	.if  !Eax
		or   Ps.MinimumWorkingSetSize, -1
		or   Ps.MaximumWorkingSetSize, -1
		lea  eax,                      Ps
		push sizeof(QUOTA_LIMITS)
		push eax
		push ProcessQuotaLimits
		push NtCurrentProcess
		%PCALL CRC_NT_SET_INFORMATION_PROCESS, 4
	.endif
	ret
WsEmpty endp

MM_READONLY          equ 1
MM_EXECUTE           equ 2
MM_EXECUTE_READ      equ 3
MM_READWRITE         equ 4
MM_WRITECOPY         equ 5
MM_EXECUTE_READWRITE equ 6
MM_EXECUTE_WRITECOPY equ 7
MM_NOCACHE           equ 8
MM_GUARD_PAGE        equ 16
MM_SHARED            equ 100H       ; i8

CRC_NTDLL            equ 084C05E40H

SFC  struct
Next PVOID ?
Ip   PVOID ?
SFC  ends
PSFC typedef ptr SFC

CRC_NTDLL        equ 084C05E40H
CRC_WOW64        equ 05632AEDFH
CRC_WOW64CPU     equ 0A22330FBH
CRC_WOW64WIN     equ 0025B7DE6H

CRC_CRC_NTDLL    equ 0FD5D14ECH
CRC_CRC_WOW64    equ 0E3EDA609H
CRC_CRC_WOW64CPU equ 0D2391E8FH
CRC_CRC_WOW64WIN equ 03938DF48H

; +
;
	assume fs:NOTHING
	
WsGet proc uses ebx esi edi
Local Self:RANGE, Exe:RANGE
Local Mem[512]:ULONG
Local Wse:DWORD
Local N:ULONG
Local Crc[128]:ULONG
	xor esi, esi          ; CRC
	and N,   0
	mov ecx, fs:[TEB.ProcessEnvironmentBlock]
	invoke MmQueryViewSize, PEB.ImageBaseAddress[Ecx], addr Exe
	.if !Eax
		invoke MmQueryViewSize, SFC.Ip[Ebp], addr Self
		.if !Eax
			lea  eax, Mem
			push NULL
			push 512*4
			push eax
			push MemoryWorkingSetList
			push 0
			push NtCurrentProcess
			%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
			.if  !Eax
				mov ebx, MEMORY_WORKING_SET_LIST.NumberOfEntries[Mem]
				.repeat
					mov eax, MEMORY_WORKING_SET_LIST.WorkingSetInfo[Mem][ebx*4][-4]
					bt  eax, 1                                                      ; MM_EXECUTE | MM_EXECUTE_READWRITE | MM_EXECUTE_WRITECOPY
					mov Wse, eax
					.if Carry?
						.if (Eax < Self.Base) || (Eax >= Self.Limit) ; ~ current
							.if (Eax < Exe.Base) || (Eax >= Exe.Limit) ; ~ exe
								invoke MmCrc, Wse
								.if    !Eax       ; !File
									bt Wse, 8 ; Shared for XP
									jc Skip
								.else
									lea edi, Crc
									mov ecx, N
									repne scasd
									je  Skip
									stosd
									inc N
								.endif
								%DBG "WsGet 0x%p 0x%X", Eax, Wse
								invoke Crc32D, Esi, Eax
								mov esi, eax
								; ntdll.dll
								; wow64.dll
								; wow64cpu.dll
							.endif
						.endif
					.endif
				Skip:
					dec ebx
				.until Zero?
			.endif
		.endif
	.endif
	mov eax, esi
Exit:
	ret
WsGet endp

.data
align 4
MMCRC DD (0FD5D14ECH + MM_KEY) xor 06ADB8788H
		DD (0D2391E8FH + MM_KEY) xor 0E49FC949H
		DD (099A6461BH + MM_KEY) xor 0A3C5CE7FH
		DD (0388602B9H + MM_KEY) xor 007618D31H
		DD (0A0174EB4H + MM_KEY) xor 01A058165H
		DD (02636B05CH + MM_KEY) xor 03ED0859EH
		DD (0E74D4982H + MM_KEY) xor 062E65170H
		DD (0616CB76AH + MM_KEY) xor 04633558BH
		DD (0673C0E37H + MM_KEY) xor 0E603BF0AH
		DD (0C61C4A95H + MM_KEY) xor 042A7FC44H
		DD (0C5C8F424H + MM_KEY) xor 054F45700H
		DD (0E2C94E6EH + MM_KEY) xor 0D48510B5H

MMCRC2 DD 06ADB8788H
		DD 0E49FC949H
		DD 0A3C5CE7FH
		DD 007618D31H
		DD 01A058165H
		DD 03ED0859EH
		DD 062E65170H
		DD 04633558BH
		DD 0E603BF0AH
		DD 042A7FC44H
		DD 054F45700H
		DD 0D48510B5H

.code
; +
;
WsCrc2Key proc uses edi Crc:DWORD
	invoke Crc32D, CRC32_BASE, Crc
	lea edi, MMCRC2
	mov ecx, 12
	repne scasd
	.if Zero?
		not ecx
		xor eax, MMCRC[ecx*4][12*4]
		sub eax, Crc
		xor ecx, ecx
	.endif
	ret
WsCrc2Key endp

; +
;
NtAlloc   proc S1ze:ULONG
Local     Base:PVOID
	and  Base, 0
	lea  ecx,  S1ze
	lea  edx,  Base
	push PAGE_READWRITE
	push MEM_COMMIT
	push ecx
	push 0
	push edx
	push NtCurrentProcess
	%ENVR Eax, NtMemory.Alloc
	%RCALL 6
	mov  eax,  Base
	ret
NtAlloc endp

; +
;
NtFree  proc Base:PVOID
Local   S1ze:ULONG
	and  S1ze, 0
	lea  ecx,  S1ze
	lea  edx,  Base
	push MEM_RELEASE
	push ecx
	push edx
	push NtCurrentProcess
	%ENVR Eax, NtMemory.Free
	%RCALL 4
	ret
NtFree endp

; +
;
MmAlloc proc uses ebx Mem:PRANGE, Portion:ULONG, S1ze:ULONG
	mov    ebx,        Mem
	assume ebx:PRANGE
	cmp    [ebx].Base, NULL
	je     @f
	mov    eax,        [ebx].Base
	mov    ecx,        S1ze
	mov    edx,        [ebx].Limit
	add    [ebx].Base, ecx
	.if    [Ebx].Base >= Edx
		and [ebx].Base, NULL
	@@:
		mov  eax,         Portion
		lea  ecx,         [ebx].Limit
		lea  edx,         [ebx].Base
		mov  [ebx].Limit, eax
		push PAGE_READWRITE
		push MEM_COMMIT
		push ecx
		push 0
		push edx
		push NtCurrentProcess
		%ENVR Eax, NtMemory.Alloc
		%RCALL 6
		.if  !Eax
			mov eax,         [ebx].Base
			mov ecx,         S1ze
			add [ebx].Limit, eax
			add [ebx].Base,  ecx
		.endif
	.endif
	ret
MmAlloc endp

; +
;
MmMap proc uses ebx esi Section:PHANDLE, S1ze:ULONG, ExBase:PPVOID, RwBase:PPVOID
Local   Obj:OBJECT_ATTRIBUTES
Local   SectionSize:LARGE_INTEGER
Local   SectionOffset:LARGE_INTEGER
	mov  ebx,                           Section
	mov  eax,                           S1ze
	xor  esi,                           esi
	mov  DWORD PTR[SectionSize][0],     eax
	mov  Obj.uLength,                   sizeof(OBJECT_ATTRIBUTES)
	mov  DWORD PTR[SectionSize][4],     esi
	mov  Obj.hRootDirectory,            esi
	mov  Obj.pObjectName,               esi
	mov  Obj.uAttributes,               esi
	mov  Obj.pSecurityDescriptor,       esi
	mov  Obj.pSecurityQualityOfService, esi
	mov  DWORD PTR[SectionOffset][0],   esi
	mov  DWORD PTR[SectionOffset][4],   esi
	push esi
	push SEC_COMMIT
	push PAGE_EXECUTE_READWRITE
	lea  eax,                           SectionSize
	lea  ecx,                           Obj
	push eax
	push ecx
	push SECTION_ALL_ACCESS
	push ebx
	%PCALL CRC_NT_CREATE_SECTION, 7
	.if  !Eax
		if OPT_RWE eq TRUE
			push PAGE_EXECUTE_READWRITE
		else
			push PAGE_EXECUTE_READ
		endif
		push esi
		push ViewShare
		lea  eax, S1ze
		lea  ecx, SectionOffset
		push eax
		push ecx
		push esi
		push esi
		push ExBase
		push NtCurrentProcess
		push DWORD PTR[ebx]
		%PCALL CRC_NT_MAP_VIEW_OF_SECTION, 10
		.if  !Eax
			push PAGE_READWRITE
			push esi
			push ViewShare
			lea  eax, S1ze
			lea  ecx, SectionOffset
			push eax
			push ecx
			push esi
			push esi
			push RwBase
			push NtCurrentProcess
			push DWORD PTR[ebx]
			%PCALL CRC_NT_MAP_VIEW_OF_SECTION, 10
			test eax, eax
			jz   Exit
			
			mov  ecx, ExBase
			push eax
			push DWORD PTR[ecx]
			push NtCurrentProcess
			%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
			pop  eax
		.endif
		push eax
		push DWORD PTR[ebx]
		%PCALL CRC_NT_CLOSE, 1
		pop  eax
	.endif
Exit:
	ret
MmMap endp

OPT_CRC_SIZE equ 256

; --
;
MmSelfCheck proc uses ebx esi edi Section:HANDLE, Relocs:PVOID, Reader:PVOID, pCrc:PVOID
Local Mem:MEMORY_BASIC_INFORMATION
Local SectionOffset:LARGE_INTEGER
Local Base:PVOID, S1ze:ULONG
Local Buffer[256]:DWORD
	invoke Mm87GetIp
	lea    ecx, Mem
	push   NULL
	push   sizeof(MEMORY_BASIC_INFORMATION)
	push   ecx
	push   MemoryBasicInformation
	push   eax
	push   NtCurrentProcess
	%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
	.if    !Eax
		mov DWORD PTR[SectionOffset][0], eax
		mov DWORD PTR[SectionOffset][4], eax
		mov Base,                        eax
		mov S1ze,                        eax
		
		push PAGE_READWRITE
		push eax
		push ViewShare
		lea  ebx, S1ze
		lea  ecx, SectionOffset
		lea  edx, Base
		push ebx
		push ecx
		push eax
		push eax
		push edx
		push NtCurrentProcess
		push Section
		%PCALL CRC_NT_MAP_VIEW_OF_SECTION, 10
		.if  !Eax
			mov  ecx, Base
			add  ecx, S1ze
			sub  ecx, (sizeof(MEMORY_BASIC_INFORMATION) + 7) and NOT(7) ; Align to 8.
			push eax
			push sizeof(MEMORY_BASIC_INFORMATION)
			push ecx
			push MemoryBasicInformation
			push Mem.BaseAddress
			push NtCurrentProcess
			%PCALL CRC_NT_QUERY_VIRTUAL_MEMORY, 6
			push eax
			
			push Base
			push NtCurrentProcess
			%PCALL CRC_NT_UNMAP_VIEW_OF_SECTION, 2
			pop  eax
			.if  !Eax
				mov    ebx, Mem.AllocationBase
				add    ebx, S1ze
				sub    ebx, (sizeof(MEMORY_BASIC_INFORMATION) + 7) and NOT(7)
				assume ebx:PMEMORY_BASIC_INFORMATION

				lea  ecx,  [ebx].AllocationBase
				push ecx
				Call Reader
				mov  Base, eax
				
				lea  ecx, [ebx]._Type
				lea  edx, [ebx].Protect
				push ecx
				push edx
				Call Reader
				mov  ebx, eax
				Call Reader
				xor  ebx, eax           ; MEM_MAPPED + PAGE_EXECUTE_READ
				
				mov ecx, S1ze
				shr ecx, 3
				invoke Crc32, Ebx, Relocs, Ecx	; * DF
				xor ebx, eax  ; K

				sub S1ze, ((sizeof(MEMORY_BASIC_INFORMATION) + 7) and NOT(7)) - 1
				xor esi,  esi                                                     ; Offset
				xor edi,  edi                                                     ; Length
			Calc:
				mov eax,            Relocs
				bt  DWORD PTR[eax], esi
				.if Carry?
					.if Edi > OPT_CRC_SIZE - 4
						inc edi
						invoke Crc32, Ebx, addr Buffer, Edi
						mov ebx, eax
						xor edi, edi
					.endif
					mov  eax,                   Base
					add  eax,                   esi
					push eax
					Call Reader
					sub  eax,                   Base
					mov  DWORD PTR Buffer[edi], eax
					add  edi,                   4
					add  esi,                   4
					jmp  Calc
				.endif
				.if Edi == OPT_CRC_SIZE
					invoke Crc32, Ebx, addr Buffer, Edi
					mov ebx, eax
					xor edi, edi
				.endif
				.if S1ze > Esi
					mov  eax,                  Base
					add  eax,                  esi
					push eax
					Call Reader
					mov  BYTE PTR Buffer[edi], al
					inc  esi
					inc  edi
					jmp  Calc
				.endif
				.if Edi
					inc edi
					invoke Crc32, Ebx, addr Buffer, Edi
					mov ebx, eax
				.endif
				mov ecx,            pCrc
				xor eax,            eax
				mov DWORD PTR[ecx], ebx
			.endif
		.endif
	.endif
	ret
MmSelfCheck endp

; +
;
MmCheckIp   proc
	%ISWOW
	.if Carry?
		Call @f
	.else
		invoke Tr86Sexit
		push   edx
	.endif
@@:
	invoke Mm87GetIp
	push   eax
	%PCALL CRC_NT_ARE_MAPPED_FILES_THE_SAME, 2
	push   eax          ; STATUS_SUCCESS
	%ENVP Ecx
	push   [ecx].NtBase
	Call   @f
@@:
	%PCALL CRC_NT_ARE_MAPPED_FILES_THE_SAME, 2
	pop ecx
	xor eax, ecx ; STATUS_NOT_SAME_DEVICE
	ret
MmCheckIp endp