
; Data Types
LARGE_INTEGER struct
    LowPart  DWORD ?
    HighPart DWORD ?
LARGE_INTEGER          ends

PLARGE_INTEGER         typedef ptr LARGE_INTEGER

FILE_BASIC_INFORMATION struct
	CreationTime   QWORD ?
	LastAccessTime QWORD ?
	LastWriteTime  QWORD ?
	ChangeTime     QWORD ?
	FileAttributes QWORD ?
FILE_BASIC_INFORMATION  ends
PFILE_BASIC_INFORMATION typedef ptr FILE_BASIC_INFORMATION

FileBasicInformation equ 4
CHAR                     typedef BYTE
WCHAR                    typedef WORD

OBJECT_BASIC_INFORMATION struct
    Attributes ULONG ?
;    GrantedAccess       ACCESS_MASK ?
    HandleCount       ULONG ?
    PointerCount      ULONG ?
    PagedPoolUsage    ULONG ?
    NonPagedPoolUsage ULONG ?
;    Reserved[3]         ULONG ?
    NameInfoSize           ULONG ?
    TypeInfoSize           ULONG ?
    SecurityDescriptorSize ULONG ?
    CreateTime             QWORD ?
OBJECT_BASIC_INFORMATION ends

TIMER_BASIC_INFORMATION  struct
    TimeRemaining QWORD ?
    SignalState   BOOLEAN ?
TIMER_BASIC_INFORMATION      ends

SYSTEM_TIMEOFDAY_INFORMATION struct
    CurrentTime  QWORD ?
    TimeZoneBias QWORD ?
    TimeZoneId   ULONG ?
    Reserved     ULONG ?
SYSTEM_TIMEOFDAY_INFORMATION ends


; +
;
TmAccessFile                 proc uses ebx Time:PLARGE_INTEGER
Local                        Ps[MAX_PATH*2]:CHAR
Local                        Io:IO_STATUS_BLOCK
Local                        Buffer[4]:BYTE
Local                        OA:OBJECT_ATTRIBUTES
Local                        Info:FILE_BASIC_INFORMATION
Local                        File:HANDLE
Local                        S1ze:ULONG
	lea  eax, Buffer
	lea  ebx, Ps
	push eax
	push MAX_PATH*2
	push ebx
	push ProcessImageFileName
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_INFORMATION_PROCESS, 5
	.if  !Eax
		mov  OA.uLength,                   sizeof(OBJECT_ATTRIBUTES)
		mov  OA.hRootDirectory,            eax
		mov  OA.uAttributes,               eax
		mov  OA.pSecurityDescriptor,       eax
		mov  OA.pSecurityQualityOfService, eax
		mov  OA.pObjectName,               ebx
		push 60H
		push 3
		lea  eax,                          Io
		lea  ecx,                          OA
		lea  edx,                          File
		push eax
		push ecx
		push 80100080H
		push edx
		%PCALL CRC_NT_OPEN_FILE, 6
		.if  !Eax
			push FileBasicInformation
			push sizeof(FILE_BASIC_INFORMATION)
			lea  eax, Info
			lea  ecx, Io
			push eax
			push ecx
			push File
			%PCALL CRC_NT_QUERY_INFORMATION_FILE, 5
			.if  !Eax
				push eax
				push eax
				push 4
				lea  ecx, Buffer
				lea  edx, Io
				push ecx
				push edx
				push eax
				push eax
				push eax
				push File
				%PCALL CRC_NT_READ_FILE, 9
			.endif
			push eax
			push File
			%PCALL CRC_NT_CLOSE, 1
			pop  eax
		.endif
		mov ebx,               Time
		mov ecx,               DWORD PTR Info.LastAccessTime[0]
		mov edx,               DWORD PTR Info.LastAccessTime[4]
		mov DWORD PTR[ebx][0], ecx
		mov DWORD PTR[ebx][4], edx
	.endif
	ret
TmAccessFile endp

; +
;
TmNewObject  proc uses ebx esi edi Time:PLARGE_INTEGER
Local        OA:OBJECT_ATTRIBUTES
Local        Object:OBJECT_BASIC_INFORMATION
Local        Sym:HANDLE
Local        SymU:UNICODE_STRING
Local        Buffer[4]:WORD
Local        TickCount:DWORD

    xor eax,                          eax
    mov OA.uLength,                   sizeof(OBJECT_ATTRIBUTES)
    mov OA.hRootDirectory,            eax
    mov OA.uAttributes,               eax
    mov OA.pSecurityDescriptor,       eax
    mov OA.pSecurityQualityOfService, eax
    mov OA.pObjectName,               eax
        
    and DWORD PTR [Buffer+4], 0
    lea eax,                  Buffer
    mov SymU._Length,         4
    mov SymU.MaximumLength,   6
    mov SymU.Buffer,          eax

    .repeat
        ; Заменяем rdtsc на вызов GetTickCount
        push eax            ; Сохраняем eax
        push ecx            ; Сохраняем ecx (может быть изменен при вызове функции)
        call GetTickCount
        mov  TickCount, eax
        pop  ecx            ; Восстанавливаем ecx
        pop  eax            ; Восстанавливаем eax

        mov dx,                  WORD PTR [TickCount+2]
        mov ax,                  WORD PTR [TickCount]
        mov WORD PTR [Buffer+2], dx
        mov WORD PTR [Buffer],   ax
        
        lea  eax, SymU
        lea  ecx, OA
        lea  edx, Sym
        push eax
        push ecx
        push SYMBOLIC_LINK_ALL_ACCESS
        push edx
        %PCALL CRC_NT_CREATE_SYMBOLIC_LINK_OBJECT, 4
    .until !eax

    lea  ecx, Object
    push NULL
    push sizeof(OBJECT_BASIC_INFORMATION)
    push ecx
    push ObjectBasicInformation
    push Sym
    %PCALL CRC_NT_QUERY_OBJECT, 5
    push eax
    push Sym
    %PCALL CRC_NT_CLOSE, 1
    pop  eax
    .if  !eax
        mov ebx,               Time
        mov ecx,               DWORD PTR [Object.CreateTime]
        mov edx,               DWORD PTR [Object.CreateTime+4]
        mov DWORD PTR [ebx],   ecx
        mov DWORD PTR [ebx+4], edx
    .endif
    ret
TmNewObject        endp

; +
;
Tm86KiGetTickCount proc C
	Int 2AH
	ret
Tm86KiGetTickCount endp

; +
;
TmCreateTimer      proc Timer:PHANDLE
Local              OA:OBJECT_ATTRIBUTES
	xor eax,                          eax
	mov OA.uLength,                   sizeof(OBJECT_ATTRIBUTES)
	mov OA.hRootDirectory,            eax
	mov OA.uAttributes,               eax
	mov OA.pSecurityDescriptor,       eax
	mov OA.pSecurityQualityOfService, eax
	mov OA.pObjectName,               eax
	
	lea  ecx, OA
	push NotificationTimer
	push ecx
	push TIMER_ALL_ACCESS
	push Timer
	%PCALL CRC_NT_CREATE_TIMER, 4
	ret
TmCreateTimer     endp

; +
;
BaseFormatTimeOut proc Time:PLARGE_INTEGER, Tms:ULONG
	mov eax,               Tms
	mov ecx,               10000
	mul ecx
	mov ecx,               Time
	neg eax
	adc edx,               0
	neg edx
	mov DWORD PTR[ecx][0], eax
	mov DWORD PTR[ecx][4], edx
	ret
BaseFormatTimeOut endp

; +
;
TmSetTimer        proc Timer:HANDLE, Tms:ULONG
Local             Tnt:QWORD
	invoke BaseFormatTimeOut, addr Tnt, Tms
	lea  ecx, Tnt
	push NULL
	push 0
	push FALSE
	push 0
	push NULL
	push ecx
	push Timer
	%PCALL CRC_NT_SET_TIMER, 7
	ret
TmSetTimer   endp


; +
; EAX[8]	SIGNAL
;

TmQueryTimer proc uses ebx esi edi Timer:HANDLE, Time:PLARGE_INTEGER
    LOCAL State:TIMER_BASIC_INFORMATION

    and  BYTE PTR [State.SignalState], 0
    lea  ecx,                          State
    push NULL
    push sizeof(TIMER_BASIC_INFORMATION)
    push ecx
    push TimerBasicInformation
    push Timer
    %PCALL CRC_NT_QUERY_TIMER, 5
    .if  !eax
        mov ebx,               Time
        mov ecx,               DWORD PTR [State.TimeRemaining]
        mov edx,               DWORD PTR [State.TimeRemaining + 4]
        mov DWORD PTR [ebx],   ecx
        mov DWORD PTR [ebx+4], edx
        
        movzx eax, State.SignalState
    .endif
    ret
TmQueryTimer  endp
;
;
TmCurrentTime proc Time:PLARGE_INTEGER
Local         Info:SYSTEM_TIMEOFDAY_INFORMATION
	lea  eax, Info
	push NULL
	push sizeof(SYSTEM_TIMEOFDAY_INFORMATION)
	push eax
	push SystemTimeOfDayInformation
	%PCALL CRC_NT_QUERY_SYSTEM_INFORMATION, 4
	.if  !Eax
		mov eax,               Time
		mov ecx,               DWORD PTR Info.CurrentTime[0]
		mov edx,               DWORD PTR Info.CurrentTime[4]
		mov DWORD PTR[eax][0], ecx
		mov DWORD PTR[eax][4], edx
		xor eax,               eax
	.endif
	ret
TmCurrentTime endp

; +
;
TmWait        proc Object:HANDLE, Tms:ULONG
Local         Tnt:LARGE_INTEGER
	invoke BaseFormatTimeOut, addr Tnt, Tms
	lea  ecx, Tnt
	push ecx
	push FALSE
	push Object
	%PCALL CRC_NT_WAIT_FOR_SINGLE_OBJECT, 3
	ret
TmWait endp
						
;
;
TmInit proc uses ebx
    %ENVP Ebx
    invoke TmCreateTimer, addr [Ebx].Timer
    %DBG "TmInit.TmCreateTimer 0x%X", Eax
    .if    !Eax
	;TODO
        ;invoke TmSetTimer, [Ebx].Timer, OPT_TIME_OUT
        ;%DBG "TmInit.TmSetTimer 0x%X", Eax
        .if !Eax
            invoke TmAccessFile, addr [Ebx].Time.File
            %DBG "TmInit.TmAccessFile 0x%X", Eax
            .if    !Eax
                invoke TmAccessFile, addr [Ebx].Time.File
                %DBG "TmInit.TmAccessFile 0x%X", Eax
                .if    !Eax
                    invoke TmNewObject, addr [Ebx].Time.Object
                    %DBG "TmInit.TmNewObject 0x%X", Eax
                .endif
            .endif
        .endif
    .endif
    ret
TmInit endp
