.686
.model     flat, stdcall
option     casemap:none

include    \masm32\32\include\ntdll.inc
includelib \masm32\32\include\ntdll.lib
		
include    \masm32\32\include\user32.inc
includelib \masm32\32\include\user32.lib
include    \masm32\32\include\kernel32.inc
includelib \masm32\32\include\kernel32.lib
includelib \masm32\32\include\msvcrt.lib

OPT_DEBUG      equ FALSE
OPT_RWE        equ FALSE      ; +RWE
OPT_NTNAME     equ FALSE      ; +NT AVL.Name
OPT_SEXIT_KILL equ FALSE      ; +SYSEXIT check.
OPT_SEXIT_SUB  equ FALSE
OPT_TURBO_OFF  equ FALSE      ; -WOW turbo dispatch.
OPT_SCRC_SIZE  equ 64
OPT_STACK_SIZE equ 512
OPT_DBG_OFF    equ TRUE
OPT_WAIT_TIME  equ 64         ; ms
OPT_TIME_OUT   equ 1000       ; ms
CRC32_BASE     equ 0

MM_KEY         equ -19283746H
ST_KEY         equ 0BADC0DEH


PVOID           typedef ptr BYTE
ULONG           typedef DWORD
BOOLEAN         typedef BYTE
PSTR            typedef ptr BYTE
PUNICODE_STRING typedef ptr UNICODE_STRING
PHANDLE         typedef ptr HANDLE
PTLS            typedef ptr TLS
PENV            typedef ptr ENV
PRANGE          typedef ptr RANGE


.code
$App db "App", 0

include         Id.inc
include         Crc.inc
include         Avl.inc
include         Head.inc
include         Gate.asm
include         log.asm
include         Ts.asm
include         CBR.asm
include         Time.asm
include         Trace.asm
include         Mem.asm
include         Wow.asm
include         Nt.asm
include         Pe.asm
	
; +
; Edx:Eax	Ticks
; Ecx:	EFlags
;
x64GetTickCount proc C
	DB 09CH, 0B9H, 020H, 003H, 0FEH, 07FH, 048H, 08BH, 009H, 08BH, 004H, 025H, 004H, 000H, 0FEH, 07FH
	DB 048H, 00FH, 0AFH, 0C1H, 048H, 0C1H, 0E8H, 018H, 048H, 089H, 0C2H, 048H, 0C1H, 0EAH, 020H, 059H
	DB 0CAH, 008H, 000H
x64GetTickCount endp

; R11D: @Args
;
	
; Scall via turbo.
;	DB 048H, 031H, 0C9H			; xor rcx,rcx
;	DB 064H, 08BH, 00CH, 025H 	; mov ecx,fs:[DTLS]		:PTLS
;	DD DTLS
;	DB 067H, 08BH, 089H			; mov ecx,[ecx][TLS.Tid]	:TURBO_ID
;	DD TLS.Tid
;	DB 0C1H, 0E9H, 010H			; shr ecx,16
;	DB 041H, 0FFH, 024H, 0CFH	; jmp [r15][rcx*8]

; Scall without turbo.
%TH64SYS macro
	DB 041H, 0FFH, 027H			; jmp [r15]
endm

; Return to gate.
%TH64RET macro
	DB 049H, 08BH, 04FH, 008H	; mov rcx,[r15][8]		TurboThunkDispatch[8]:Thunk0Arg
	DB 083H, 0C1H, 005H			; add ecx,5			~ call_CpupSyscallStub
	DB 0FFH, 0E1H ; jmp rcx
endm

; +
;
Ww64TurboThunk proc C
	DB 066H, 085H, 0C0H			; test ax,ax
	DB 075H, L2 - L1 ; jne L2
L1:
	DB 09CH, 0B9H, 020H, 003H, 0FEH, 07FH, 048H, 08BH, 009H, 08BH, 004H, 025H, 004H, 000H, 0FEH, 07FH
	DB 048H, 00FH, 0AFH, 0C1H, 048H, 0C1H, 0E8H, 018H, 048H, 089H, 0C2H, 048H, 0C1H, 0EAH, 020H, 059H

	DB 048H, 033H, 0C9H			; xor rcx,rcx
	DB 067H, 064H, 08BH, 089H	; mov ecx,fs:[ecx][TEB.ProcessEnvironmentBlock]
	DD TEB.ProcessEnvironmentBlock
	DB 067H, 08BH, 089H			; mov ecx,[ecx][DENV]
	DD DENV
	DB 067H, 089H, 081H	 		; mov [ecx][],eax
	DD ENV.Time.NtTicks[0]
	DB 067H, 089H, 091H			; mov [ecx][],edx
	DD ENV.Time.NtTicks[4]
	
	DB 0B8H                                           ; mov eax,N
	DD CRC_NT_QUERY_INFORMATION_PROCESS xor 64624367H
	%TH64RET
L2:
	DB 041H, 0FFH, 043H, 004H	; inc D[r11][4] -> ProcessDebugFlags
	DB 00FH, 0B7H, 0C0H			; movzx eax,ax
	DB 048H, 033H, 0C9H			; xor rcx,rcx
	DB 067H, 064H, 08BH, 089H	; mov ecx,fs:[ecx][TEB.ProcessEnvironmentBlock]
	DD TEB.ProcessEnvironmentBlock
	DB 067H, 08BH, 089H			; mov ecx,[ecx][DENV]
	DD DENV
	DB 067H, 00FH, 0BAH, 0B9H	; btc [ecx][ENV.Key],N
	DD ENV.Key
	DB 0
	%TH64SYS
Ww64TurboThunk endp

CbReader       proc P
	mov eax, P
	mov eax, DWORD PTR[eax]
	ret
CbReader endp

	%NTCALLCRC

%SCRC1 macro
	%TLSP Ecx
	bts [ecx].Flags, TF_SCRC
endm

%SCRC0 macro
	%TLSP Ecx
	btr [ecx].Flags, TF_SCRC
endm

%SCRCX macro
	%TLSP Ecx
	xor [ecx].Crc, eax
endm

%SCRCK macro
	%TLSP Ecx
	xchg [ecx].Crc, eax
endm

CRC_ZW_SET_INFORMATION_THREAD    equ 0C8277BF4H
CRC_ZW_QUERY_INFORMATION_PROCESS equ 05E7088EDH
CRC_ZW_REMOVE_PROCESS_DEBUG      equ 0F23FE980H

; +
; 
StkTrap proc uses ebx esi edi
Local   NtSystemCallAddresses[2]:PVOID
Local   DebugFlags:DWORD

    ; Load system call addresses from ntdll.dll
    mov NtSystemCallAddresses[0*4], CRC_ZW_SET_INFORMATION_THREAD
    mov NtSystemCallAddresses[1*4], CRC_ZW_QUERY_INFORMATION_PROCESS
    %ENVR Ecx, NtBase
    invoke PeQueryRoutinesFast, Ecx, addr NtSystemCallAddresses

    .if Zero?
        ; Attempt to hide thread from debugger
        if OPT_DBG_OFF eq TRUE
            push 0
            push 0
            push ThreadHideFromDebugger
            push NtCurrentThread
            Call StkpCrc
            Call NtSystemCallAddresses[0*4] ; ZwSetInformationThread
            Call StkpCrc
        endif

        ; Check for debugger presence
        lea  ecx, DebugFlags
        push 0
        push 4                          ; sizeof(DWORD)
        push ecx
        push ProcessDebugObjectHandle
        push NtCurrentProcess
        Call StkpCrc
        Call NtSystemCallAddresses[1*4] ; ZwQueryInformationProcess
        Call StkpCrc
    .endif

    ret

StkpCrc:
    xchg   esp, ebx
    invoke Stk86Crc
    xchg   esp, ebx
    retn
StkTrap   endp

; +
;
TrIsDebug proc
Local     Dbg:PVOID
	if OPT_DBG_OFF eq TRUE
		push NULL
		push NULL
		push ThreadHideFromDebugger
		push NtCurrentThread
		%PCALL CRC_NT_SET_INFORMATION_THREAD, 4
	endif
	lea  ecx, Dbg
	push NULL
	push sizeof(PVOID)
	push ecx
	push ProcessDebugObjectHandle
	push NtCurrentProcess
	%PCALL CRC_NT_QUERY_INFORMATION_PROCESS, 5
	.if  !Eax
		push eax                 ; STATUS_PORT_NOT_SET
		if   OPT_DBG_OFF eq TRUE
			push Dbg
			push NtCurrentProcess
			%PCALL CRC_NT_REMOVE_PROCESS_DEBUG, 2
		endif
		push Dbg
		%PCALL CRC_NT_CLOSE, 1
		pop  eax
 	.endif
	ret
TrIsDebug endp

; +
; OUT:
;	(KEY)
;	(STK)	ST_KEY
;	EAX		MM_KEY/0
;	TR[0]	RPL
;	TR[1]	GS
;
Setup     proc uses ebx esi edi
Local     Env:TENV
Local     Dbg:BOOLEAN
Local     Tnt:LARGE_INTEGER
	lea    esi,          Env
	xor    eax,          eax
	mov    edi,          esi
	mov    ecx,          sizeof(TENV)/4
	rep stosd
	%ENVS Esi
	assume esi:PENV
	invoke TrRpl
	%DBG "RPL 0x%X", Eax
	setz   BYTE PTR [esi].Trace[0]      ; TR[0]: T
	invoke PeGetNativeBase
	mov    [esi].NtBase, eax
	%DBG "Setup.PeGetNativeBase 0x%p", Eax
	.if    Eax
		invoke NtGateInit, Esi
		%DBG "Setup.NtGateInit 0x%X", Eax
		.if    Eax
			invoke NtAlloc, sizeof(ENV)
			%DBG "Setup.ENV 0x%p", Eax
			.if    Eax
				mov    ebx, eax
				mov    edi, eax
				mov    ecx, sizeof(TENV)/4
				rep movsd
				assume ebx:PENV
				%ENVS Ebx
				
				invoke NtTree, [Ebx].NtBase, addr [Ebx].NtTree
				.if Eax
					invoke MmCheckIp                       ; STATUS_NOT_SAME_DEVICE
					invoke Crc32D, Eax, Eax
					mov    [ebx].Key,    eax
					%DBG "Setup.NTCRC 0x%X", Eax
					invoke NtAlloc,      256 * sizeof(TLS)
					mov    [ebx].TsBase, eax               ; Switch to full-env.
					%DBG "Setup.TLS 0x%p", Eax
					.if    Eax
						mov    ecx, 8
						mov    eax, -1
						lea    edi, [ebx].TsMap
						rep stosd
						invoke TsGet
						mov    esi, eax
						assume esi:PTLS
						%DBG "Setup.TsGet 0x%p", Eax

						mov    eax,       ST_KEY
						%SCRCK
						%SCRC1
						invoke WsEmpty
						invoke TmInit
						test   eax,       eax
						jnz    Error
						invoke StkTrap           ; STATUS_PORT_NOT_SET
						%DBG "Setup.StkTrap 0x%X STKCRC 0x%X", [Esi].Crc, Eax
						xor    [ebx].Key, eax
						%DBG "Setup.Key 0x%X", [Ebx].Key
						invoke NtReTree
						%DBG "Setup.STKCRC 0x%X", [Esi].Crc
						%DBG "Setup.NtReTree 0x%X", Eax
						invoke TrIsDebug         ; STATUS_PORT_NOT_SET
						%DBG "Setup.TrIsDebug 0x%X", Eax
						%DBG "Setup.STKCRC 0x%X", [Esi].Crc
						not    eax
						invoke Crc32D, CRC32_BASE, Eax
						xor    [ebx].Key, eax
						%DBG "Setup.Key 0x%X", [Ebx].Key
						%CHKSTK 4
;TODO
;						invoke TmQueryTimer, [Ebx].Timer, addr Tnt
						%DBG "Setup.TmQueryTimer 0x%X", Eax
						jnz    Error
						invoke Crc32D, CRC32_BASE, Eax
						xor    [ebx].Key, eax
						invoke WsGet
						%DBG "Setup.WsGet 0x%X", Eax
						%DBG "Setup.STKCRC 0x%X", [Esi].Crc
						invoke WsCrc2Key, Eax    ; MM_KEY = f(WSL)
						%DBG "Setup.WsCrc2Key 0x%X", Eax
						%DBG "Setup.STKCRC 0x%X", [Esi].Crc
						mov    edi,       eax
						if     OPT_DEBUG eq TRUE
							xor eax, eax
						endif
						.if Zero?
							%ISWOW
							.if Carry?
								invoke TrCMSexitFlags
								jc     Error
								%DBG "Setup.WOW"
								invoke TrCMGs
								%DBG "Setup.GS 0x%X", Eax
								setc   BYTE PTR [ebx].Trace[1] ; TR[1]: T
								%DBG "Setup.STKCRC 0x%X", [Esi].Crc
								invoke WwSetup
								%DBG "Setup.WwSetup 0x%X", Eax
								test   eax, eax
								jz     Error
								%DBG "Setup.STKCRC 0x%X", [Esi].Crc
								if     OPT_DEBUG eq TRUE
									lea eax, Ww64TurboThunk
								else
									lea eax, Ww64TurboThunk[edi][-MM_KEY]
								endif
								%TURBOSET
								xor eax, eax
;TODO
;								mov Dbg,eax
								%TURBOCALL
								%DBG "Setup.TURBOCALL 0x%X", Eax
								%DBG "Setup.STKCRC 0x%X", [Esi].Crc
								xor    eax,       64624367H  ; CRC_NT_QUERY_INFORMATION_PROCESS
								invoke NtCrcToId, Eax
								%DBG "Setup.NtCrcToId 0x%X", Eax
								lea    ecx,       Dbg
								push   NULL
								push   4
								push   ecx
								push   ProcessDebugFlags - 1
								push   NtCurrentProcess
								%TURBOCALL 5	; ~KEY[0]
								%DBG "Setup.TURBOCALL 0x%X", Eax
								%DBG "Setup.STKCRC 0x%X", [Esi].Crc
								%DBG "Setup.Key 0x%X", [Ebx].Key
;TODO
;								%DBG "Setup.Debug 0x%X", Dbg
								%DBG "Setup.NtTime 0x%X: 0x%X", Edx, DWORD PTR [Ebx].Time.NtTicks[0], DWORD PTR [Ebx].Time.NtTicks[4]
							.else
								%DBG "Setup.X86"
								invoke Tr86Sexit
								%DBG "Setup.Tr86Sexit 0x%X", Eax
								setz   al
								movzx  eax,       al
								xor    [ebx].Key, eax
								%DBG "Setup.Key 0x%X", [Ebx].Key
								invoke Tr86Gs
								%DBG "GS 0x%X", Eax
								setz   BYTE PTR [ebx].Trace[1] ; TR[1]: T
								
								invoke Tm86KiGetTickCount
								mov    DWORD PTR [ebx].Time.NtTicks[0], eax
								mov    DWORD PTR [ebx].Time.NtTicks[4], edx
								%DBG "Setup.NtTime 0x%X: 0x%X", Edx, Eax
							.endif
							
							invoke NtCrcToId, CRC_NT_CALLBACK_RETURN
							mov    [ebx].Rid, eax
							
							invoke NtGetUserId
							mov    [ebx].Gid, eax
							%DBG "Setup.NtGetUserId 0x%X", Eax
;TODO							
;							invoke TmWait, [Ebx].Timer, OPT_WAIT_TIME
;							%DBG "Setup.TmWait 0x%X", Eax
							xor [ebx].Key, eax
							
							%SCRC0
							mov eax, edi
							jmp Exit
						.endif
					.endif
				.endif
			.endif
		.endif
	.endif
Error:
	xor eax, eax
Exit:
	ret
Setup endp

$Fn1  DB "ZwQueryInformationProcess", 0
$Fn2  DB "ZwSetInformationThread",    0
$Fn3  DB "ZwRemoveProcessDebug",      0

KEYVAL equ 7F65210AH

PUBLIC EntryPoint
	assume fs:nothing
EntryPoint proc uses ebx esi edi
Local Km:DWORD

	invoke LgInit
	invoke Setup
	mov    Km, eax
	.if    Eax
		%ENVP Ebx
		%TLSP Esi
		invoke Crc32D, [Esi].Crc, [Ebx].Key
		.if Eax == 7419A326H
			invoke RtGetSize
			%DBG "Start.RtGetSize 0x%X", Eax
			mov    [ebx].Gsz, eax
			.if    Eax
				invoke SvMsgBox, Km
				invoke SvGetTicks
				invoke SvAtom
				
				invoke RtAtom
				.if    !Carry?
					xor esp, esp
					jmp esp
				.endif
				%DBG "INIT.RTATOM 0x%X", Eax
				invoke RtGetTicks
				%DBG "INIT.RTGETTICKS 0x%X", Eax
				%ENVP Ebx
				sub    eax, DWORD PTR [ebx].Time.NtTicks[0]
				.if    (Eax < OPT_TIME_OUT)
					invoke RtMsgBox
				.endif
			.endif
		.endif
	.endif
	invoke ExitProcess, 0
Exit:
	ret
EntryPoint endp
	BYTE 64 DUP (?)


end EntryPoint